#pragma once

#include "PreCompiledHeaders.hh"
#include "Lib/Ass/StyleProperties.hh"

namespace Vivy::Ass
{
class Line;

class Syl final {
private:
    QString content;
    StyleProperties styleProperties;
    quint64 duration{ 0 };

public:
    Line *parentLine;

public:
    enum class ConstructMode {
        Raw,        // Don't read ASS tags
        ReadAssTags // Read ass tags
    };

    explicit Syl(Line *const, const QString &,
                 ConstructMode mode = ConstructMode::ReadAssTags) noexcept;

    QString getContent() const noexcept;
    quint64 getDuration() const noexcept;

    QString getAssText() const noexcept;

    void setDuration(quint64) noexcept;

private:
    static quint64 getDurationFromString(const QString &) noexcept;
};
}
