#pragma once

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "Lib/Document/VivyDocument.hh"
#include "Lib/Utils.hh"
#include "Lib/CRTPStore.hh"

namespace Vivy
{
class VivyDocumentStore final : public CRTPStore<VivyDocumentStore, VivyDocument> {
    VIVY_STORAGE_CLASS(VivyDocumentStore, VivyDocument)

public:
    explicit VivyDocumentStore() noexcept = default;

    // Create a new empty document with no backing file for the moment
    std::shared_ptr<VivyDocument> newDocument(VivyDocument::Options opt = VivyDocument::NoOption);
};

}
