#include "PreCompiledHeaders.hh"
#include "Lib/Script/ScriptStore.hh"
#include "Lib/Uuid.hh"

using namespace Vivy;
using namespace std::string_literals;

ScriptStore::ScriptStore() noexcept { resetLoadedScripts(); }

void
ScriptStore::loadScriptFolder(const QString &folderPath)
{
    QDir folder(folderPath);
    const auto filter = QDir::Files | QDir::NoSymLinks | QDir::Readable;

    // Load all module files, the loadDocument will ask for the implementation
    // file.
    for (const QString &file : folder.entryList(filter)) {
        if (!Utils::scriptFileSuffix.contains(QFileInfo(file).suffix()))
            continue;

        auto doc = loadDocument(file);
    }
}

std::vector<ScriptStore::Item>
ScriptStore::getLoadedScripts() const noexcept
{
    std::vector<ScriptStore::Item> ret;
    for (auto const &[uuid, docPtr] : documents)
        ret.emplace_back(Item{ uuid, docPtr->getName() });
    return ret;
}

void
ScriptStore::resetLoadedScripts() noexcept
{
    logInfo() << "TODO";
}

bool
ScriptStore::executeScript(Uuid id) noexcept
{
    logInfo() << "TODO";
    return false;
}

bool
ScriptStore::executeScript(Uuid id, std::shared_ptr<Vivy::VivyDocument> doc) noexcept
{
    logInfo() << "TODO";
    return false;
}
