#pragma once

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "Lib/AbstractMediaContext.hh"

namespace Vivy
{
// Hold all the data for a video stream. Should only be owned by the parent
// VideoContext instance.
class VideoStream final : public AbstractMediaStream<AVMEDIA_TYPE_VIDEO> {
    VIVY_UNMOVABLE_OBJECT(VideoStream)

public:
    VideoStream(const AVCodec *, AVFormatContext *, AVStream *, int index);
    ~VideoStream() noexcept override = default;

    int getWidth() const noexcept;
    int getHeight() const noexcept;
    double getFramesPerSecond() const noexcept;

    QJsonObject getProperties() const noexcept override;
};

// Like an audio context, but for videos.
class VideoContext final : public AbstractMediaContext<VideoStream> {
    VIVY_UNMOVABLE_OBJECT(VideoContext)

public:
    VideoContext(const QString &path);

    QString getElementName() const noexcept override;
    QJsonDocument getProperties() const noexcept override;
};
}
