use criterion::{criterion_group, criterion_main, Criterion};
use vvs_parser::prelude::{ast::*, parser::*};

const T_SOURCE: &str = include_str!("./t.lua");

fn parse(criterion: &mut Criterion) {
    criterion.bench_function("get ast from parsed t", move |b| b.iter(|| parse_lua_tree(T_SOURCE)));
}

fn range(criterion: &mut Criterion) {
    let ast = parse_lua_tree(T_SOURCE).unwrap();
    criterion.bench_function("get range of ast of t", move |b| b.iter(|| ast.nodes().range()));
}

criterion_group! {
    name = benches;
    config = Criterion::default().sample_size(20);
    targets = parse, range
}

criterion_main!(benches);
