use std::ffi::NulError;
use thiserror::Error;
use vvs_shortstring::ShortString;

#[derive(Debug, Error)]
pub enum CodegenError {
    #[error("redefinition of function: {0}.{1}")]
    RedefinedFunction(ShortString, ShortString),

    #[error("nul byte in string: {0}")]
    NulError(NulError),

    #[error("{0}")]
    Error(ShortString),
}
