//! Re-exports LLVM stuff, and create some safe bindings for ease of use

#[cfg(feature = "sys")]
pub mod sys {
    pub use llvm_sys::{
        analysis::*,
        core::*,
        error::*,
        orc2::{ee::*, lljit::*, *},
        prelude::*,
        target::*,
        target_machine::*,
        transforms::pass_builder::*,
        *,
    };
}

#[cfg(feature = "bindings")]
pub mod prelude {
    pub use crate::bindings::{
        basic_block::*, builder::*, context::*, function::*, jit::JIT, module::*, types::*, value::*,
        Error as LLVMError,
    };
}

#[cfg(feature = "bindings")]
mod bindings;

#[cfg(feature = "init")]
pub mod init;

#[cfg(feature = "link")]
pub mod build;
