if exists('b:current_syntax') | finish |  endif
let b:current_syntax = 'vivy script'

syn keyword VVKeywords          option import set repeat main end do then typeof yield
syn keyword VVKeywords          for while if else return local in elseif elif until
syn keyword VVOperators         or xor not and mod
syn keyword VVBoolean           true false
syn keyword VVSelf              self

syn keyword VVDeclCallable      function job nextgroup=VVSDeclCallableName
syn match   VVDeclCallableName  '[a-zA-Z_][a-zA-Z_0-9]*\ze('
syn match   VVType              ':\ *\zs[a-zA-Z_][a-zA-Z_0-9]*\(<[a-zA-Z_][a-zA-Z_0-9]*>\)\?'

syn region  VVString1           start=/"/ skip=/\\"/ end=/"/
syn region  VVString2           start=/'/ skip=/\\'/ end=/'/
syn region  VVString3           start=/\[\[/ end=/\]\]/
syn match   VVNumber            /-\?\<\d\+\.\d*\(e[+-]\d\+\)\?\>/
syn match   VVNumber            /-\?\<\d\+\>/

syn match   VVComment1          "--\(-\)\?.*$"
syn region  VVComment2          start="--\(-\)\?\[\[*" end="\]\]"

syn match   VVVariable          '[A-Z_][A-Z_0-9]*'

hi def link VVDeclCallable      Keyword
hi def link VVDeclCallableName  Function
hi def link VVKeywords          Keyword
hi def link VVOperators         Keyword
hi def link VVSelf              Constant
hi def link VVType              Type
hi def link VVComment1          Comment
hi def link VVComment2          Comment
hi def link VVNumber            Float
hi def link VVBoolean           Boolean
hi def link VVString1           String
hi def link VVString2           String
hi def link VVString3           String
