#![forbid(unsafe_code)]

mod enums;
mod vvrt;

use proc_macro::TokenStream;
use syn::parse_macro_input;

#[proc_macro_derive(EnumVariantCount)]
pub fn derive_enum_variant_count(input: TokenStream) -> TokenStream {
    enums::impl_derive_enum_variant_count(parse_macro_input!(input as syn::DeriveInput)).into()
}

#[proc_macro_derive(EnumVariantIter)]
pub fn derive_enum_variant_iter(input: TokenStream) -> TokenStream {
    enums::impl_derive_enum_variant_iter(parse_macro_input!(input as syn::DeriveInput)).into()
}

#[proc_macro_derive(EnumVariantFromStr)]
pub fn derive_enum_variant_from_str(input: TokenStream) -> TokenStream {
    enums::impl_derive_enum_variant_from_str(parse_macro_input!(input as syn::DeriveInput)).into()
}

#[proc_macro_attribute]
pub fn vvrt_bridge(arg: TokenStream, input: TokenStream) -> TokenStream {
    vvrt::impl_vvrt_bridge(parse_macro_input!(arg as syn::Ident).to_string(), parse_macro_input!(input as syn::ItemMod))
        .unwrap()
        .into()
}
