#include "TimingSyl.hh"

#include "TimingParams.hh"
#include "TimingSeparator.hh"

using namespace Vivy;

TimingSyl::TimingSyl(Ass::Syl syl_, int startTime, QGraphicsItem *parent)
    : QGraphicsObject(parent)
    , syl(syl_)
{
    setZValue(Z_LINE_SYL_TEXT);
    setPos(getTimingParam()->posFromMs(startTime), 0);
}

QRectF
TimingSyl::boundingRect() const
{
    return QRectF(0, 0, int(syl.getDuration()), getTimingParam()->audioHeight());
}

void
TimingSyl::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
{
    painter->drawText(boundingRect(), Qt::AlignCenter, syl.getContent());
}

void
TimingSyl::setLen(quint64 len)
{
    prepareGeometryChange();
    syl.setDuration(len);
}
