#!/usr/bin/env bash
set -e
exec 5>&1
cd "$(git rev-parse --show-toplevel)"

FILES=$(cargo build --manifest-path src/Rust/Cargo.toml --workspace ${2} --message-format=json \
    | jq -r 'select( .reason == "compiler-artifact" and ((.target.kind | index("staticlib")) or (.target.kind | index("bin"))) ) .filenames[0]' \
    | tee >(cat - >&5))

for FILE in ${FILES}; do
    FILE=${FILE}
    cp -u ${FILE} "${1}/$(basename ${FILE})"
done
